/*
 *                       Yeppp! library implementation
 *                   This file is auto-generated by Peach-Py,
 *        Portable Efficient Assembly Code-generator in Higher-level Python,
 *                  part of the Yeppp! library infrastructure
 * This file is part of Yeppp! library and licensed under the New BSD license.
 * See library/LICENSE.txt for the full text of the license.
 */

using System.Runtime.InteropServices;

namespace Yeppp
{

	public partial class Core
	{

		public static unsafe float DotProduct_V32fV32f_S32f(float[] xArray, int xOffset, float[] yArray, int yOffset, int length)
		{
			fixed (float* xPointer = &xArray[xOffset])
			{
				fixed (float* yPointer = &yArray[yOffset])
				{
					return DotProduct_V32fV32f_S32f(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe double DotProduct_V64fV64f_S64f(double[] xArray, int xOffset, double[] yArray, int yOffset, int length)
		{
			fixed (double* xPointer = &xArray[xOffset])
			{
				fixed (double* yPointer = &yArray[yOffset])
				{
					return DotProduct_V64fV64f_S64f(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe float DotProduct_V32fV32f_S32f(float* xPointer, float* yPointer, int length)
		{
			float dotProduct;
			yepCore_DotProduct_V32fV32f_S32f(xPointer, yPointer, out dotProduct, new System.UIntPtr(unchecked((uint) length)));
			return dotProduct;
		}


		public static unsafe double DotProduct_V64fV64f_S64f(double* xPointer, double* yPointer, int length)
		{
			double dotProduct;
			yepCore_DotProduct_V64fV64f_S64f(xPointer, yPointer, out dotProduct, new System.UIntPtr(unchecked((uint) length)));
			return dotProduct;
		}


		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_DotProduct_V32fV32f_S32f")]
		private static unsafe extern Status yepCore_DotProduct_V32fV32f_S32f(float* x, float* y, out float dotProduct, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_DotProduct_V64fV64f_S64f")]
		private static unsafe extern Status yepCore_DotProduct_V64fV64f_S64f(double* x, double* y, out double dotProduct, System.UIntPtr length);

	}

}
