#
#                      Yeppp! library implementation
#
# This file is part of Yeppp! library and licensed under the New BSD license.
# See library/LICENSE.txt for the full text of the license.
#

__author__ = 'Marat'

class Status:
    Ok = 0
    NullPointer = 1
    MisalignedPointer = 2
    InvalidArgument = 3
    InvalidData = 4
    InvalidState = 5
    UnsupportedHardware = 6
    UnsupportedSoftware = 7
    InsufficientBuffer = 8
    OutOfMemory = 9
    SystemError = 10
    AccessDenied = 11

class License:
    header_license = """                           Yeppp! library header
                  This file is auto-generated by Peach-Py,
       Portable Efficient Assembly Code-generator in Higher-level Python,
                   part of the Yeppp! library infrastrure

This file is part of Yeppp! library and licensed under the New BSD license.

Copyright (C) 2010-2012 Marat Dukhan
Copyright (C) 2012-2013 Georgia Institute of Technology
All rights reserved.
 
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the Georgia Institute of Technology nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.""".split("\n")

    source_license = """                      Yeppp! library implementation
                  This file is auto-generated by Peach-Py,
       Portable Efficient Assembly Code-generator in Higher-level Python,
                 part of the Yeppp! library infrastructure
This file is part of Yeppp! library and licensed under the New BSD license.
See library/LICENSE.txt for the full text of the license.""".split("\n")
